package jvm;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;

public class heapGc {

    private byte[] bytes = new byte[1024 * 100]; // 1M

    //cmd jvisualvm可以看到jvm的内存、线程等使用情况
    //arthas调优,https://alibaba.github.io/arthas
    public static void main(String[] args) {
        heapGc heapGc = new heapGc();
        heapGc.deadLock();
    }

    private void gc()  throws InterruptedException{
        List<heapGc> list = new ArrayList<>();
        while (true) {
            list.add(new heapGc());
            Thread.sleep(5);
        }
    }

    private void cpuHigh(){
        new Thread(() -> {
            while (true) {

            }
        }).start();
    }

    private void deadLock(){
        Object a = new Object();
        Object b = new Object();
        Thread threadA = new Thread(() -> {
            synchronized (a) {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                synchronized (b) {
                    System.out.println("get b");
                }
            }
        });

        Thread threadB = new Thread(() -> {
            synchronized (b) {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                synchronized (a) {
                    System.out.println("get a");
                }
            }
        });

        threadA.start();
        threadB.start();
    }
}
